/**
 * Register DynoSearcho behavior 
*/
Drupal.behaviors.dynosearcho = function (context) { 
  $('input.dynosearcho-searchbox').each(function () {
    var delta = $(this).parent().siblings("input[name='dynosearcho_delta']").val();
    var input = '#edit-dynosearcho-search-' + delta;
    var expres = '#edit-dynosearcho-exp-' + delta;
    var wrapper = '#dynosearcho-results-' + delta; 
    var searchon = $('#edit-dynosearcho-integrated-search-' + delta).val();
    dynoPreventEnter (input, searchon);
    dynoTriggerAhah(input, expres, wrapper);
  });
}
/**
 * Register DynoSearcho block configuration behavior
 */
Drupal.behaviors.dynosearchoAdmin = function (context) {
  //----- set the default state
  $('fieldset#dynosearcho-nodesearch').hide();
  $('fieldset#dynosearcho-usersearch').hide();
  switch($('input.dynosearcho-searchtype:checked').val()) {
    case 'node':
      $('fieldset#dynosearcho-nodesearch').show();
      break;
    case 'user':
      $('fieldset#dynosearcho-usersearch').show();
      break;
  }
 //----- update the boxes as radio buttons are clicked
  $('input.dynosearcho-searchtype').click(function () {
    if ($(this).val() == 'node') {
      $('fieldset#dynosearcho-usersearch').hide();
      $('fieldset#dynosearcho-nodesearch').slideDown();
    } 
    else {
      $('fieldset#dynosearcho-nodesearch').hide();
      $('fieldset#dynosearcho-usersearch').slideDown();
    } 
  });
}
/**
 * Helper function to prevent the enter key used to submit the form here, if integrated search is off
 */
dynoPreventEnter = function(input, searchon) {
  $(input).bind('keydown', function(e) {
    if (!e) {
      e = window.event;
    }
    switch (e.keyCode) {
      case 13: // enter
        if (searchon != 1) {
          e.preventDefault();
        }else{
          $(this).unbind('keyup');
        }
    }
  });
}
/**
 * Helper function - triggers blur() event on ahah form element to execute ahah search.
 */
dynoTriggerAhah = function(input, expres, wrapper) {
  var delay = 300;
  $(input).unbind('keyup').bind('keyup', function () {
    if (this.value.length == 0) {
      $(wrapper).hide();
      $(wrapper).empty();
    }else{
      $(wrapper).show();
      $('.throbber').remove();
      $(expres).val(this.value);
        if (this.timer) {
          clearTimeout(this.timer);
        }
        this.timer = setTimeout(function() {
          $(expres).blur();
        }, delay);
    }
    });
}